<?php
/*
Plugin Name: Widgets for SourceForge Reviews
Plugin Title: Widgets for SourceForge Reviews Plugin
Plugin URI: https://wordpress.org/plugins/widgets-for-sourceforge-reviews/
Description: Embed SourceForge reviews fast and easily into your WordPress site. Increase SEO, trust and sales using SourceForge reviews.
Tags: sourceforge, reviews, ratings, recommendations, testimonials, widget, slider, review, rating, recommendation, testimonial, customer review
Author: Trustindex.io <support@trustindex.io>
Author URI: https://www.trustindex.io/
Contributors: trustindex
License: GPLv2 or later
Version: 9.1
Text Domain: widgets-for-sourceforge-reviews
Domain Path: /languages/
Donate link: https://www.trustindex.io/prices/
*/
/*
Copyright 2019 Trustindex Kft (email: support@trustindex.io)
*/
defined( 'ABSPATH' ) or die( 'No script kiddies please!' );
require_once plugin_dir_path( __FILE__ ) . 'trustindex-plugin.class.php';
$trustindex_pm_sourceForge = new TrustindexPlugin_sourceForge("sourceForge", __FILE__, "9.1", "Widgets for SourceForge Reviews", "SourceForge");
register_activation_hook(__FILE__, array($trustindex_pm_sourceForge, 'activate'));
register_deactivation_hook(__FILE__, array($trustindex_pm_sourceForge, 'deactivate'));
add_action('admin_menu', array($trustindex_pm_sourceForge, 'add_setting_menu'), 10);
add_filter('plugin_action_links', array($trustindex_pm_sourceForge, 'add_plugin_action_links'), 10, 2);
add_filter('plugin_row_meta', array($trustindex_pm_sourceForge, 'add_plugin_meta_links'), 10, 2);
if(!function_exists('register_block_type'))
{
add_action('widgets_init', array($trustindex_pm_sourceForge, 'init_widget'));
add_action('widgets_init', array($trustindex_pm_sourceForge, 'register_widget'));
}
if(is_file($trustindex_pm_sourceForge->getCssFile()))
{
add_action('init', function() {
global $trustindex_pm_sourceForge;
if(!isset($trustindex_pm_sourceForge) || is_null($trustindex_pm_sourceForge))
{
require_once plugin_dir_path( __FILE__ ) . 'trustindex-plugin.class.php';
$trustindex_pm_sourceForge = new TrustindexPlugin_sourceForge("sourceForge", __FILE__, "9.1", "Widgets for SourceForge Reviews", "SourceForge");
}
$path = wp_upload_dir()['baseurl'] .'/'. $trustindex_pm_sourceForge->getCssFile(true);
if(is_ssl())
{
$path = str_replace('http://', 'https://', $path);
}
wp_register_style('ti-widget-css-sourceForge', $path, [], filemtime($trustindex_pm_sourceForge->getCssFile()));
});
}
add_action('init', array($trustindex_pm_sourceForge, 'init_shortcode'));
add_filter('script_loader_tag', function($tag, $handle) {
if(strpos($tag, 'trustindex.io/loader.js') !== false && strpos($tag, 'defer async') === false) {
$tag = str_replace(' src', ' defer async src', $tag );
}
return $tag;
}, 10, 2);
add_action('init', array($trustindex_pm_sourceForge, 'register_tinymce_features'));
add_action('init', array($trustindex_pm_sourceForge, 'output_buffer'));
add_action('wp_ajax_list_trustindex_widgets', array($trustindex_pm_sourceForge, 'list_trustindex_widgets_ajax'));
add_action('admin_enqueue_scripts', array($trustindex_pm_sourceForge, 'trustindex_add_scripts'));
add_action('rest_api_init', array($trustindex_pm_sourceForge, 'init_restapi'));
add_action('admin_notices', function() {
$rate_us = get_option('trustindex-sourceForge-rate-us', time() - 1);
if($rate_us == 'hide' || (int)$rate_us > time())
{
return;
}
$dir = plugin_dir_path( __FILE__ );
$usage_time = time() + 10;
if(is_dir($dir))
{
$usage_time = filemtime($dir) + (1 * 86400);
}
if($usage_time > time())
{
return;
}
?>
<div class="notice notice-warning is-dismissible trustindex-popup" style="position: fixed; top: 50px; right: 20px; padding-right: 30px; z-index: 1">
<p>
<?php echo TrustindexPlugin_sourceForge::___("Hello, I am happy to see that you've been using our <strong>%s</strong> plugin for a while now!", ["Widgets for SourceForge Reviews"]); ?><br>
<?php echo TrustindexPlugin_sourceForge::___("Could you please help us and give it a 5-star rating on WordPress?"); ?><br><br>
<?php echo TrustindexPlugin_sourceForge::___("-- Thanks, Gabor M."); ?>
</p>
<p>
<a href="<?php echo admin_url("admin.php?page=widgets-for-sourceforge-reviews/settings.php&rate_us=open"); ?>" class="trustindex-rateus" style="text-decoration: none" target="_blank">
<button class="button button-primary"><?php echo TrustindexPlugin_sourceForge::___("Sure, you deserve it"); ?></button>
</a>
<a href="<?php echo admin_url("admin.php?page=widgets-for-sourceforge-reviews/settings.php&rate_us=later"); ?>" class="trustindex-rateus" style="text-decoration: none">
<button class="button button-secondary"><?php echo TrustindexPlugin_sourceForge::___("Maybe later"); ?></button>
</a>
<a href="<?php echo admin_url("admin.php?page=widgets-for-sourceforge-reviews/settings.php&rate_us=hide"); ?>" class="trustindex-rateus" style="text-decoration: none">
<button class="button button-secondary" style="float: right"><?php echo TrustindexPlugin_sourceForge::___("Do not remind me again"); ?></button>
</a>
</p>
</div>
<?php
});
if(class_exists('Woocommerce') && !class_exists('TrustindexWoocommercePlugin') && !function_exists('ti_woocommerce_notice'))
{
function ti_woocommerce_notice() {
$rate_us = get_option('trustindex-wc-notification', time() - 1);
if($rate_us == 'hide' || (int)$rate_us > time())
{
return;
}
?>
<div class="notice notice-warning is-dismissible" style="margin: 5px 0 15px">
<p><strong><?php echo TrustindexPlugin_sourceForge::___("Download our new <a href='%s' target='_blank'>%s</a> plugin and get features for free!", [ 'https://wordpress.org/plugins/customer-reviews-for-woocommerce/', TrustindexPlugin_sourceForge::___('Customer Reviews for WooCommerce') ]); ?></strong></p>
<ul style="list-style-type: disc; margin-left: 10px; padding-left: 15px">
<li><?php echo TrustindexPlugin_sourceForge::___('set up Trustindex company profile and get high quality backlink'); ?></li>
<li><?php echo TrustindexPlugin_sourceForge::___('set up review-collector campaigns to get new ratings / reviews / recommendations automatically'); ?></li>
<li><?php echo TrustindexPlugin_sourceForge::___('show customer reviews in fancy widgets'); ?></li>
</ul>
<p>
<a href="<?php echo admin_url("admin.php?page=widgets-for-sourceforge-reviews/settings.php&wc_notification=open"); ?>" target="_blank" class="trustindex-rateus" style="text-decoration: none">
<button class="button button-primary"><?php echo TrustindexPlugin_sourceForge::___("Download plugin"); ?></button>
</a>
<a href="<?php echo admin_url("admin.php?page=widgets-for-sourceforge-reviews/settings.php&wc_notification=hide"); ?>" class="trustindex-rateus" style="text-decoration: none">
<button class="button button-secondary"><?php echo TrustindexPlugin_sourceForge::___("Do not remind me again"); ?></button>
</a>
</p>
</div>
<?php
}
add_action('admin_notices', 'ti_woocommerce_notice');
}
add_action('plugins_loaded', array($trustindex_pm_sourceForge, 'plugin_loaded'));
add_action('wp_ajax_nopriv_'. $trustindex_pm_sourceForge->get_webhook_action(), $trustindex_pm_sourceForge->get_webhook_action());
add_action('wp_ajax_'. $trustindex_pm_sourceForge->get_webhook_action(), $trustindex_pm_sourceForge->get_webhook_action());
function trustindex_reviews_hook_sourceForge() {
global $trustindex_pm_sourceForge;
global $wpdb;
$token = isset($_REQUEST['token']) ? sanitize_text_field($_REQUEST['token']) : "";
if(isset($_REQUEST['test']) && $token == get_option($trustindex_pm_sourceForge->get_option_name('review-download-token')))
{
echo $token;
exit;
}
$our_token = $trustindex_pm_sourceForge->is_review_download_in_progress();
if(
!$token
|| !$trustindex_pm_sourceForge->is_noreg_linked()
|| !$trustindex_pm_sourceForge->is_noreg_table_exists()
|| $our_token != $token
) {
global $wp_query;
$wp_query->set_404();
status_header(404);
exit;
}
$name = 'Unknown source';
if(isset($_REQUEST['error']) && $_REQUEST['error'])
{
update_option($trustindex_pm_sourceForge->get_option_name('review-download-inprogress'), 'error', false);
}
else
{
if(isset($_REQUEST['details']))
{
$name = sanitize_text_field($_REQUEST['details']['name']);
$trustindex_pm_sourceForge->save_details($_REQUEST['details']);
$trustindex_pm_sourceForge->save_reviews(isset($_REQUEST['reviews']) ? $_REQUEST['reviews'] : []);
}
delete_option($trustindex_pm_sourceForge->get_option_name('review-download-inprogress'));
delete_option($trustindex_pm_sourceForge->get_option_name('review-manual-download'));
}
update_option($trustindex_pm_sourceForge->get_option_name('download-timestamp'), time() + (86400 * 10), false);
try
{
$subject = 'SourceForge reviews downloaded';
$message = "
Hello,<br /><br />
Your request to download the reviews of ". $name ." (SourceForge page) has been successfully completed and the Trustindex plugin has received the result.<br /><br />
What's next?<br />
1. Check the widget in the plugin and change the settings if needed <br />
2. Put the widget's shortcode into your pages to increase trust in your visitors <br />
3. You may want to try the paid features (multiple platforms at once, multiple layouts, filters, automatic review updates, auto collect new reviews, ...) <br />";
$headers = [ 'Content-Type: text/html; charset=UTF-8' ];
wp_mail(get_option('admin_email'), $subject, $message, $headers, [ '' ]);
}
catch(Exception $e) { }
echo $our_token;
exit;
}
?>